unit ProgrammePrincipal;

(* unit main       v1.0      *)
(* auteur : barrault jrmy  *)
(* date :  31/05/07          *)

(* L'unite main contient la fiche principale du jeu de serpent *)
(* Elle utilise les units serpent et bonus                    *)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus , Serpent , Bonus, ComCtrls, Score ;

CONST

LIMITE : integer = 100 ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MNUFichier: TMenuItem;
    MNUNouvelle: TMenuItem;
    HorlogeSolo: TTimer;
    MNUQuitter: TMenuItem;
    Option1: TMenuItem;
    MNUdifficulte: TMenuItem;
    MNUDebutant: TMenuItem;
    MNUIntermediaire: TMenuItem;
    MNUExpert: TMenuItem;
    BarreSolo: TStatusBar;
    MNUAide: TMenuItem;
    MNUAPropos: TMenuItem;
    MNUHelp: TMenuItem;
    MNURecord: TMenuItem;
    MNUReset: TMenuItem;
    Solitaire1: TMenuItem;
    MNUBattle: TMenuItem;
    Compteur: TTimer;
    HorlogeOrdinateurBattle: TTimer;
    HorlogeJoueurBattle: TTimer;
    BarreBattle1: TStatusBar;
    BarreBattle2: TStatusBar;
    procedure HorlogeSoloTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MNUQuitterClick(Sender: TObject);
    procedure MNUIntermediaireClick(Sender: TObject);
    procedure MNUDebutantClick(Sender: TObject);
    procedure MNUExpertClick(Sender: TObject);
    procedure MNUAProposClick(Sender: TObject);
    procedure MNUHelpClick(Sender: TObject);
    procedure MNUResetClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Solitaire1Click(Sender: TObject);
    procedure MNUBattleClick(Sender: TObject);
    procedure HorlogeOrdinateurBattleTimer(Sender: TObject);
    procedure HorlogeJoueurBattleTimer(Sender: TObject);
    procedure CompteurTimer(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;



var
  Form1: TForm1;
  MonSerpent : TSerpent;
  SonSerpent : TSerpent;
  MonBonus : TBonus;
  MonScore : TScore;



implementation

{$R *.dfm}



(******************************************************************************)
(*                    Front montant Timer Joueur                              *)
(*                          (Mode solitaire)                                  *)
(******************************************************************************)
procedure TForm1.HorlogeSoloTimer(Sender: TObject);
begin

 //test collision avec soit meme, et les murs + avancer
 if Not MonSerpent.avancer( Form1) then      //si on se mort la queue ou si rencontre mur
 begin

   //arret  du jeu
   horlogeSolo.Enabled := false;  //on arrete l'horloge : le jeu

   //destruction des objets visuels
   MonSerpent.Detruire;       //efface le serpent
   MonSerpent := nil;
   Monbonus.Detruire;         //efface le bonus
   MonBonus := nil;

   //affichage message Game over ou high score
   if Not MonScore.VerificationRecordSolo then
   showmessage('   GAME OVER   !!!');

   ///actualisation des affcichages
   MNUDifficulte.Enabled := true;   //on autorise le changement de difficult
   BarreSolo.Panels.Items[2].Text :=  'Recordman : '+ MonScore.RecordManSolo;
   BarreSolo.Panels.Items[1].Text :=  'Record : '+inttostr(MonScore.RecordSolo);

 end
 else    //pas de collision avec mur ou queue

 //si on rencontre un bonus
 if MonSerpent.TestBonus(Monbonus) then    //si on rencontre un bonus
 begin

 //actualisation du score
 MonScore.AugmenterJoueur( 10* Monbonus.NumGenre ); //10 point pour les bonus de type 1, 20 type 2 et 30 type 3
 BarreSolo.Panels.Items[0].Text := 'Score Actuel : '+inttostr(MonScore.scorejoueur);

   //affichage d'un nouveau bonus pas dans le serpents
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until MonSerpent.TestPresenceSerpent( MonBonus.left , MonBonus.top  ) = false ;

  //actualisation du serpent
  MonSerpent.grandir;      //on grandit le serpent de 1
  HorlogeSolo.interval := MonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3
  
 end;



end;



(******************************************************************************)
(*                 Touche du clavier prsse                                  *)
(******************************************************************************)
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin

//on envoie pas Key  changerdedirection pour pouvoir eventuellement changer
//les touches de direction facilement, par exemple  z,q,s,d, 
//ou meme mettre la souris !


if (MonSerpent = nil ) and (key <> VK_CONTROL) then    //meme si pas de jeu en cours on autorise le mode anti patron
  exit; // si pas de jeu en cours


case Key of

80 :       begin                         //pause
             if SonSerpent = nil then     //mode solo
             HorlogeSolo.Enabled:= Not HorlogeSolo.Enabled
             else
             //mode battle
             Compteur.Enabled := Not Compteur.Enabled;
             HorlogeJoueurBattle.Enabled := Not HorlogeJoueurBattle.Enabled;
             HorlogeOrdinateurBattle.Enabled := Not HorlogeOrdinateurBattle.Enabled;

           end;

VK_LEFT :  begin
             MonSerpent.changerdirection(GAUCHE)
           end;// flche gauche

VK_UP :    begin
             MonSerpent.changerdirection(HAUT)
           end;// flche haut

VK_RIGHT : begin
             MonSerpent.changerdirection(DROITE)
           end;// flche droite

VK_DOWN :  begin
             MonSerpent.changerdirection(BAS)
           end;// flche bas

VK_CONTROL : begin          //mode anti patron

               //minimise la fenetre
               Form1.windowstate := wsMinimized;

               //arrete les timers ( pause )
               HorlogeSolo.enabled:=false;
               HorlogeOrdinateurBattle.Enabled := false;
               HorlogeJoueurBattle.Enabled := false;
               Compteur.Enabled:=false;
               
             end;
end;



end;



(******************************************************************************)
(*                    Quitter                                                 *)
(******************************************************************************)
procedure TForm1.MNUQuitterClick(Sender: TObject);
begin
Form1.Close;  //fermeture de l'application
end;


(******************************************************************************)
(*                    Niveaux Dbutant                                        *)
(******************************************************************************)
procedure TForm1.MNUIntermediaireClick(Sender: TObject);
begin
MNUDifficulte.Tag := 2;
end;


(******************************************************************************)
(*                   Niveaux intermediaire                                    *)
(******************************************************************************)
procedure TForm1.MNUDebutantClick(Sender: TObject);
begin
MNUDifficulte.Tag := 1;
end;


(******************************************************************************)
(*                       Niveaux Expert                                       *)
(******************************************************************************)
procedure TForm1.MNUExpertClick(Sender: TObject);
begin
MNUDifficulte.Tag := 3;
end;


(******************************************************************************)
(*                    A Propos                                                *)
(******************************************************************************)
procedure TForm1.MNUAProposClick(Sender: TObject);
begin
   showmessage('JBSoft V1.0'+#13+'Contact '+' jeje_delbarro@hotmail.com');
end;


(******************************************************************************)
(*                    AIDe                                                    *)
(******************************************************************************)
procedure TForm1.MNUHelpClick(Sender: TObject);
begin
   //message d'aide de prsentation du jeu
   showmessage('JBSoft prsente SNAKE'+#13+
                       #13+'SNAKE est un jeu de serpent classique qui se joue'+
                       #13+' l''aide des touches directionnelles du clavier et'+
                       #13+'ou vous devrez manger des bonus pour pouvoir grandir'+
                       #13+'et marquer des points.'+
                       #13+'La touche p met ou enlve le jeu du mode pause.'+
                       #13+'La touche Ctrl est un mode anti patron qui cache le'+
                       #13+'jeu et le met en mode pause.'+
                       #13+'Plusieurs niveaux sont disponible : '+
                       #13+'  - Le niveau dbutant qui donne accs aux bonus'+
                       #13+'    verts turquoise d''une valeur de 10 points.'+
                       #13+'  - Le niveau intermdiaire qui donne accs aux'+
                        #13+'   bonus bleus foncs d''une valeur de 20 points'+
                       #13+'    et qui fait grandir le serpent deux fois plus vite.'+
                       #13+'  - Le niveau expert qui donne accs aux bonus'+
                       #13+'    violets d''une valeur de 30 points, qui fait'+
                       #13+'    grandir le serpent deux fois plus vite et qui'+
                       #13+'    acclre ce dernier.'+
                       #13+'Pour battre le record vous devrez sans doute passer'+
                       #13+'par ce niveau.'
                        );

end;


(******************************************************************************)
(*                    Remise  zro des records dans la BDR                   *)
(******************************************************************************)
procedure TForm1.MNUResetClick(Sender: TObject);
begin

  MonScore.MiseAZeroRecords;
  BarreSolo.Panels.Items[2].Text :=  'Recordman : ';
  BarreSolo.Panels.Items[1].Text :=  'Record : 0';
  BarreBattle2.Panels.Items[0].Text := 'Temps record : 0';
  BarreBattle2.Panels.Items[1].Text := 'Recordman : ';

end;



(******************************************************************************)
(*                    Cration de la fiche                                    *)
(******************************************************************************)
procedure TForm1.FormCreate(Sender: TObject);
begin

 //actualisation des records et des affichages  ( recherche dans BDR )
 MonScore := TScore.creer;
 BarreSolo.Panels.Items[1].Text :=  'Record : '+inttostr(MonScore.RecordSolo);
 BarreSolo.Panels.Items[2].Text :=  'Recordman : '+MonScore.RecordManSolo;
 BarreBattle2.Panels.Items[0].Text := 'Temps record : '+inttostr(MonScore.recordbattle);
 BarreBattle2.Panels.Items[1].Text := 'Recordman : '+ MonScore.recordmanbattle;

end;


(******************************************************************************)
(*                    Lancement du mode solo                                  *)
(******************************************************************************)
procedure TForm1.Solitaire1Click(Sender: TObject);
begin


 MNUDifficulte.Enabled := false;          //on autorise pas le changement de difficult en cours de jeu
 BarreSolo.Visible := true;
 BarreBattle1.Visible := false;
 BarreBattle2.Visible := false;
 MonScore.MiseAZeroScores;
 BarreSolo.Panels.Items[0].Text := 'Score Actuel : '+inttostr(MonScore.ScoreJoueur);

 //destructions des anciens objets visuels en cas de nouvelle partie au cours d'une partie
 if MonSerpent <> nil then
 begin
   MonSerpent.detruire;
   MonSerpent := nil;
 end;
 if MonBonus <> nil then
 begin
   MonBonus.detruire;
   MonBonus := nil;
 end;
 if SonSerpent <> nil then
 begin
   SonSerpent.detruire;
   SonSerpent := nil;
 end;

 //cration des objets visuels
 MonSerpent := TSerpent.creer(Form1 , clMoneygreen );   //cration du serpent
 MonBonus := TBonus.creer(Form1 , MNUDifficulte.Tag );      //cration d'un bonus avec la difficult selectionne

 //mise en route des timers
 HorlogeSolo.interval := MonSerpent.vitesse ;       //actualisation de la vitesse de l'horloge et donc du serpent
 HorlogeSolo.Enabled := true;                      //mise en route de l'horloge : le jeu commence


end;


(******************************************************************************)
(*                    Lancement du mode battle                                *)
(******************************************************************************)
procedure TForm1.MNUBattleClick(Sender: TObject);
begin

 //actualisation des affichages
 MNUDifficulte.Enabled := false;          //on n'autorise pas le changement de difficult en cours de jeu
 BarreSolo.Visible := false;
 BarreBattle1.Visible := true;
 BarreBattle2.Visible := false;
 MonScore.MiseAZeroScores;   //RAZ des scores
 BarreBattle1.Panels.Items[0].Text := 'Score Joueur : '+inttostr(MonScore.ScoreJoueur);
 BarreBattle1.Panels.Items[1].Text := 'ScoreOrdinateur : '+inttostr(MonScore.ScoreOrdinateur);
 BarreBattle1.Panels.Items[2].Text := 'Temps : '+inttostr(MonScore.TempsBattle);

 //destructions des anciens objets visuels en cas de nouvelle partie au cours d'une partie
 if MonSerpent <> nil then
 begin
   MonSerpent.detruire;
   MonSerpent := nil;
 end;
 if MonBonus <> nil then
 begin
   MonBonus.detruire;
   MonBonus := nil;
 end;
 if SonSerpent <> nil then
 begin
   SonSerpent.detruire;
   SonSerpent := nil;
 end;

 //cration des objets visuels
 SonSerpent := TSerpent.creer( Form1 , clPurple );   //cration du serpent de l'ordinateur
 MonSerpent := TSerpent.creer( Form1 , clMoneygreen );   //cration du serpent
 MonBonus := TBonus.creer(Form1 , MNUDifficulte.Tag );      //cration d'un bonus avec la difficult selectionne

 //mise en route des timers
 HorlogeOrdinateurBattle.interval := SonSerpent.vitesse ;       //actualisation de la vitesse de l'horloge et donc du serpent
 HorlogeJoueurBattle.Interval := MonSerpent.vitesse;
 HorlogeJoueurBattle.Enabled := true;                      //mise en route de l'horloge : le jeu commence
 HorlogeOrdinateurBattle.Enabled:=true;
 Compteur.Enabled := true;



end;


(******************************************************************************)
(*                    Front montant Timer ordinateur                          *)
(*                          (Mode battle)                                     *)
(******************************************************************************)
procedure TForm1.HorlogeOrdinateurBattleTimer(Sender: TObject);
begin

 //changement de direction artificielle
 SonSerpent.ChangerdirectionAutomatique(Monbonus);

  //test collision avec soit meme, l'autre serpent, et les murs + avancer
 if ( Not SonSerpent.avancer( Form1) ) or ( MonSerpent.TestPresenceSerpent(SonSerpent.left(0), SonSerpent.top(0) )) then      //si on se mort la queue ou si rencontre mur
 begin
   SonSerpent.Detruire;       //efface le serpent
   SonSerpent := TSerpent.creer( Form1 , clpurple );   //cration du serpent de l'ordinateur
   MonScore.MiseAZeroScoreOrdinateur;
   BarreBattle1.Panels.Items[0].Text := 'Score ordinateur : '+inttostr(MonScore.Scoreordinateur);

 end
 else    //pas de collision avec mur ou queue
 begin
  //si on rencontre un bonus
 if SonSerpent.TestBonus(Monbonus) then
 begin

 //actualisation du score
 MonScore.AugmenterOrdinateur( 10* Monbonus.NumGenre );
 BarreBattle1.Panels.Items[1].Text := 'ScoreOrdinateur : '+inttostr(MonScore.ScoreOrdinateur);

 //verification fin de jeu
 if MonScore.ScoreOrdinateur >= LIMITE then
 begin

  //arret  du jeu
 HorlogeJoueurBattle.Enabled := false;
 HorlogeOrdinateurBattle.Enabled:= false;
 Compteur.Enabled := false;

   //destruction des objets visuels
   MonBonus.detruire;
   MonBonus := nil;
   MonSerpent.Detruire;       //efface le serpent
   MonSerpent := nil;
   SonSerpent.Detruire;       //efface le serpent
   SonSerpent := nil;

   //affichage message perdu
   showmessage('GAME OVER L''ordinateur triomphe avec un temps de '+ inttostr(MonScore.TempsBattle)+' secondes.' );

   ///actualisation des affcichages
   MNUDifficulte.Enabled := true;   //on autorise le changement de difficult
   BarreBattle2.Panels.Items[0].Text := 'Temps record : '+inttostr(MonScore.recordbattle);
   BarreBattle2.Panels.Items[1].Text := 'Recordman : '+ MonScore.recordmanbattle;

 end
 else  //si l'ordinateur de gagne pas
 begin

    //affichage d'un nouveau bonus pas dans un des deux serpents
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until( SonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top  ) = false ) AND   ( MonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top   ) = false );

   //actualisation du serpent
  SonSerpent.grandir;      //on grandit le serpent de 1
  HorlogeOrdinateurBattle.interval := SonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3
 end;
 end;
end;


end;


(******************************************************************************)
(*                     Front montant Timer joueur                             *)
(*                          (Mode battle)                                     *)
(******************************************************************************)
procedure TForm1.HorlogeJoueurBattleTimer(Sender: TObject);
begin

 //test collision avec soit meme, l'autre serpent, et les murs + avancer
 if ( Not MonSerpent.avancer( Form1)) or ( SonSerpent.TestPresenceSerpent(MonSerpent.left(0), MonSerpent.top(0) )) then      //si on se mort la queue ou si rencontre mur
 begin
   MonSerpent.Detruire;       //efface le serpent
   MonSerpent := TSerpent.creer( Form1 , clMoneygreen );
   MonScore.MiseAZeroScoreJoueur;
   BarreBattle1.Panels.Items[0].Text := 'Score Joueur : '+inttostr(MonScore.ScoreJoueur);
 end
 else    //pas de collision avec mur ou queue ou autre serpent
 begin
 //si on rencontre un bonus
 if MonSerpent.TestBonus(Monbonus) then
 begin

 //actualisation du score
 MonScore.AugmenterJoueur(10* Monbonus.NumGenre );
 BarreBattle1.Panels.Items[0].Text := 'Score Joueur : '+inttostr(MonScore.ScoreJoueur);

 //verification fin de jeu
 if MonScore.ScoreJoueur >= LIMITE then
 begin

 //arret  du jeu
 HorlogeJoueurBattle.Enabled := false;
 HorlogeOrdinateurBattle.Enabled:= false;
 Compteur.Enabled := false;

   //destruction des objets visuels
   MonBonus.detruire;
   MonBonus := nil;
   MonSerpent.Detruire;       //efface le serpent
   MonSerpent := nil;
   SonSerpent.Detruire;       //efface le serpent
   SonSerpent := nil;

   //affichage message gagn ou high score
   if Not MonScore.VerificationRecordBattle then 
   showmessage('WINNER !!! Vous triomphez avec un temps de '+ inttostr(MonScore.TempsBattle)+' secondes.' );

   ///actualisation des affcichages
   MNUDifficulte.Enabled := true;   //on autorise le changement de difficult
   BarreBattle2.Panels.Items[0].Text := 'Temps record : '+inttostr(MonScore.recordbattle);
   BarreBattle2.Panels.Items[1].Text := 'Recordman : '+ MonScore.recordmanbattle;

 end
 else //si le joueur ne gagne pas
 begin
   //affichage d'un nouveau bonus pas dans un des deux serpents
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until(  MonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top  )  = false ) AND ( SonSerpent.TestPresenceSerpent(MonBonus.left , Monbonus.top   ) = false );

   //actualisation du serpent
   MonSerpent.grandir;      //on grandit le serpent de 1
   HorlogeJoueurBattle.interval := MonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3
 end;
 end;
end;

end;




procedure TForm1.CompteurTimer(Sender: TObject);
begin

  //actualisation des affichages , on alterne entre les deux infobarre pour pouvoir avoir acces  toutes les infos
  MonScore.AugmenterTempsBattle(1);

  BarreBattle2.Panels.Items[2].Text := 'Temps : '+inttostr(MonScore.TempsBattle);
  BarreBattle1.Panels.Items[2].Text := 'Temps : '+inttostr(MonScore.TempsBattle);

  BarreBattle1.Visible := Not BarreBattle1.Visible;
  BarreBattle2.Visible := Not BarreBattle2.Visible;
  
    
end;

end.

