unit Score;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Registry ;



 type TScore = class(Tobject)
 private
      LeRecordSolo : integer;
      LeRecordManSolo : String;
      LeRecordBattle : integer;
      LeRecordManBattle : String;
      LeScoreJoueur : integer;
      LeScoreOrdinateur : integer;
      LeTempsBattle : integer;
 public
      constructor creer();
      function VerificationRecordSolo():boolean; //met  jour le record si battu et renvoie true si battu
      function VerificationRecordBattle():boolean; //met  jour le record si battu et renvoie true si battu
      procedure AugmenterJoueur(Augmentation : integer);
      procedure AugmenterOrdinateur(Augmentation : integer);
      procedure AugmenterTempsBattle(Augmentation : integer);
      procedure MiseAZeroTempsBattle();
      procedure MiseAZeroScores();
      procedure MiseAZeroScoreJoueur();
      procedure MiseAZeroScoreOrdinateur();
      procedure MiseAZeroRecords();
      function RecordSolo() : integer;
      function RecordManSolo() : String;
      function RecordBattle() : integer;
      function RecordManBattle() : String;
      function ScoreJoueur():integer;
      function ScoreOrdinateur():integer;
      function TempsBattle():integer;
 end;


implementation

(******************************************************************************)
(*                 Cration du score                                          *)
(******************************************************************************)
      constructor TScore.creer();
      var
      Registre: TRegistry;
      begin

      //rcupration des high score si il existe
      Registre := TRegistry.Create;
      Registre.RootKey := HKEY_CURRENT_USER;
        try
        
          Registre.OpenKey('JBSoft\Snake', True);
          //record solo
            if NOT Registre.ValueExists('Recordsolo')        //Si aucun record !!
            then Registre.WriteInteger('Recordsolo',0);      //on cr
            LeRecordSolo := Registre.ReadInteger('Recordsolo');   //on lit

            if NOT Registre.ValueExists('Recordmansolo')        //Si aucun recordman !!
            then Registre.WriteString('Recordmansolo','');      //on cr
            LeRecordmanSolo := Registre.ReadString('Recordmansolo');  //on lit

            if NOT Registre.ValueExists('RecordBattle')        //Si aucun record !!
            then Registre.WriteInteger('RecordBattle',0);      //on cr
            LeRecordBattle := Registre.ReadInteger('RecordBattle');   //on lit

            if NOT Registre.ValueExists('RecordmanBattle')        //Si aucun recordman !!
            then Registre.WriteString('RecordmanBattle','');      //on cr
            LeRecordmanBattle := Registre.ReadString('RecordmanBattle');  //on lit

       except

         showmessage('Echec de lecture criture dans la BDR, les records ne seront pas sauvegards');
         Registre.Free;
         
       end;
       
       LeScoreJoueur := 0; 
       LeScoreOrdinateur := 0;
       LeTempsBattle := 0;
       Registre.Free;

    end;


(******************************************************************************)
(*                 Vrifie si le record solo est battu                        *)
(******************************************************************************)
    function TScore.VerificationRecordSolo():boolean; //met  jour le record si battu et renvoie true si battu
    var
      Registre: TRegistry;
    begin
    result := false;

     if LeScorejoueur > LeRecordSolo then    //Si le record est battu
     begin

       result := true;
       LeRecordSolo := LeScoreJoueur ;
       LeRecordManSolo := '';

         inputquery('HIGH SCORE !!!','Veuillez saisir votre pseudo : ',LeRecordManSolo);

         try       //actualisation du recordman avec ecriture dans la BDR

           Registre := TRegistry.Create;
           Registre.OpenKey('JBSoft\Snake', True);
           Registre.WriteInteger('RecordSolo',LeScoreJoueur);
           Registre.WriteString('RecordmanSolo',LeRecordManSolo);

         except

           showmessage('Echec de lecture criture dans la BDR, les records ne seront pas sauvegards');
           Registre.Free;

         end;

         Registre.Free;

     end;


    end;


(******************************************************************************)
(*                 Vrifie si le record battle est battu                      *)
(******************************************************************************)
    function TScore.VerificationRecordBattle():boolean; //met  jour le record si battu et renvoie true si battu
    var
      Registre: TRegistry;
    begin

    result := false;

     if LeTempsBattle > LeRecordBattle then    //Si le record est battu
     begin

     result := true;
     LeRecordBattle := LeScoreJoueur ;
     LeRecordManBattle := '';

         inputquery('HIGH SCORE !!!','Veuillez saisir votre pseudo : ',LeRecordManBattle);

         try       //actualisation du recordman avec ecriture dans la BDR
           Registre := TRegistry.Create;
           Registre.OpenKey('JBSoft\Snake', True);
           Registre.WriteInteger('RecordBattle',LeScoreJoueur);
           Registre.WriteString('RecordmanBattle',LeRecordManBattle);
         except
           showmessage('Echec de lecture criture dans la BDR, les records ne seront pas sauvegards');
           Registre.Free;
         end;

     Registre.Free;

     end;

    end;


(******************************************************************************)
(*                 Incrmente le score du joueur                              *)
(******************************************************************************)
    procedure TScore.AugmenterJoueur(Augmentation : integer);
    begin
      LeScoreJoueur := LeScorejoueur + Augmentation;
    end;

(******************************************************************************)
(*                 Incrmente le score de l'ordianteru                        *)
(******************************************************************************)
    procedure TScore.AugmenterOrdinateur(Augmentation : integer);
    begin
      LeScoreOrdinateur := LeScoreOrdinateur + Augmentation;
    end;

(******************************************************************************)
(*                 Mets  zro les scores en cours                            *)
(******************************************************************************)
    procedure TScore.MiseAZeroScores();
    begin
      LeScoreJoueur := 0;
      LeScoreOrdinateur := 0;
      LeTempsBattle := 0;
    end;

(******************************************************************************)
(*                 Mets  zro le score du joueur                             *)
(******************************************************************************)
    procedure TScore.MiseAZeroScoreJoueur();
    begin
      LeScoreJoueur := 0;
    end;

(******************************************************************************)
(*                 Mets  zro le score de l'ordinateur                       *)
(******************************************************************************)
    procedure TScore.MiseAZeroScoreOrdinateur();
    begin
      LeScoreOrdinateur := 0;
    end;

(******************************************************************************)
(*                 Mets  zro les records dans la BDR                        *)
(******************************************************************************)
    procedure TScore.MiseAZeroRecords();
    var Registre : TRegistry;
    begin


      LeRecordSolo := 0;
      LeRecordManSolo := '';
      LeRecordBattle := 0;
      LeRecordManBattle := '';
      MiseAZeroScoreJoueur;

         try
           Registre := TRegistry.Create;
           Registre.OpenKey('JBSoft\Snake', True);
           Registre.WriteInteger('RecordSolo',0);
           Registre.WriteString('RecordmanSolo','');
           Registre.WriteInteger('RecordBattle',0);
           Registre.WriteString('RecordmanBattle','');
         except
           showmessage('Echec de lecture criture dans la BDR');
           Registre.Free;
         end;

      Registre.Free;
      
    end;

(******************************************************************************)
(*               Renvoie le record solo                                       *)
(******************************************************************************)
    function TScore.RecordSolo() : integer;
    begin
      result := LeRecordSolo ;
    end;

(******************************************************************************)
(*               Renvoie le recordman solo                                    *)
(******************************************************************************)
    function TScore.RecordManSolo() : String;
    begin
      result := LeRecordManSolo ;
    end;

(******************************************************************************)
(*               Renvoie le record battle                                     *)
(******************************************************************************)
    function TScore.RecordBattle() : integer;
    begin
      result := LeRecordBattle ;
    end;

(******************************************************************************)
(*               Renvoie le recordman battle                                  *)
(******************************************************************************)
    function TScore.RecordManBattle() : String;
    begin
      result := LeRecordManBattle ;
    end;


(******************************************************************************)
(*               Renvoie le score du joueur                                   *)
(******************************************************************************)
    function TScore.ScoreJoueur():integer;
    begin
      result :=LeScoreJoueur;
    end;

(******************************************************************************)
(*               Renvoie le score de l'ordinateur                             *)
(******************************************************************************)
    function TScore.ScoreOrdinateur():integer;
    begin
      result := LeScoreOrdinateur;
    end;

(******************************************************************************)
(*              Incrmente le temps de dure de la battle                     *)
(******************************************************************************)
    procedure TScore.AugmenterTempsBattle(Augmentation : integer);
    begin
     LeTempsBattle := LeTempsBattle + Augmentation;
    end;

(******************************************************************************)
(*             Mise  zro du temps battle                                    *)
(******************************************************************************)
    procedure TScore.MiseAZeroTempsBattle();
    begin
      LeTempsBattle := 0;
    end;

(******************************************************************************)
(*               Renvoie le temps battle                                      *)
(******************************************************************************)
    function TScore.TempsBattle():integer;
    begin
      result := LeTempsBattle;
    end;

    
end.

