unit Serpent;

(* unit Serpent       v1.0      *)
(* auteur : barrault jrmy     *)
(* date :  31/05/07             *)

(* L'unite Serpent contient la class TSerpent                  *)
(* TSerpent reprsente un serpent fait d'un tableau de TShape carrs *)
(* Peut etre adapt dans une futur version avec des TImage           *)
(* Il est aussi dfinit dans cette class la couleur, la direction et *)
(* le vitesse du serpent                                             *)





interface



uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls , bonus  ;

CONST

  HAUT : integer = 1;
  DROITE : integer = 2;
  BAS : integer = 3;
  GAUCHE : integer = 4;
  VITESSEMAX : integer = 50;
  VITESSEINIT : integer = 150;
  TAILLE : integer = 15;
  TAILLETETE : integer = 15;

 type Tserpent = class(Tobject)
 private
      leserpent : array of TShape;
      ladirection : array of integer;
      lacouleur :  Tcolor;
      lavitesse : integer;
 public
      constructor creer(Form : TForm ; Couleur : Tcolor );
      procedure   clone(Source : integer ; dest : integer )  ;     //copie une tshape source dans une tshape dest du serpent ( le fait avancer )
      procedure   changerdirection( nouvelledirection : integer );   //ajoute une nouvelle direction que devra emprunter le serpent
      procedure   ChangerdirectionAutomatique(MonBonus: Tbonus);    //gere le serpent automatiquement
      function    avancer(Form : Tform ):boolean; //true = collision //false = collision
      function    TestBonus(MonBonus : TBonus ):boolean;    //test si le serpent a mang un bonus renvoie true si oui
      function    TestCollision(Form : TForm ; newleft , newtop : integer ):boolean;    //test si le serpent s'est mang un mur ou la queue
      function    TestPresenceSerpent( Left , Top : Integer ):boolean; //renvoie true si le serpent est prsent a ces coordonnes
      procedure   grandir();  //grandit le serpent, pris en compte au porchain avancement
      function    top(rang : integer):integer;     //renvoie les coordonne left de la partie rang du serpent ( rang 0 = tete )
      function    left(rang : integer):integer; //renvoie les coordonne top de la partie rang du serpent ( rang 0 = tete )
      function    vitesse:integer;   //vitesse actuelle du serpent servant a cadencer le timer
      function    direction:integer;   //renvoie la direction du serpent
      destructor  detruire;   //detruis visuellement le serpent

 end;

 
implementation

(******************************************************************************)
(*                 Cration du serpent                                        *)
(******************************************************************************)
      constructor Tserpent.creer(Form : TForm ; Couleur : Tcolor );
      begin
       setlength (Leserpent , 1 );
       LeSerpent[0] := Tshape.Create(Form);
       LeSerpent[0].Parent := Form;
       LeSerpent[0].width := TAILLETETE;
       LeSerpent[0].Height := TAILLETETE;
       LeSerpent[0].top := trunc( (Form.ClientHeight-20 ) / (TAILLE *2) )*TAILLE ;         
       LeSerpent[0].Left := trunc( Form.ClientWidth / (TAILLE *2 ) ) *TAILLE ;
       LeSerpent[0].Brush.color := clRed ;
       randomize();
       setlength (LaDirection , 1);
       LaDirection[0] := trunc( random(4) )+1 ;
       Lacouleur := Couleur ;
       Lavitesse := VITESSEINIT ;
       grandir();
      end;

(******************************************************************************)
(*                 Copie de shape                                             *)
(******************************************************************************)
      procedure  TSerpent.clone(Source : integer ; dest : integer )  ;
      begin
         if LeSerpent[dest] <> nil then
           LeSerpent[dest].Destroy;
         while LeSerpent[Source] = nil do Source := Source -1;  //si on  grandit deux fois
         //suite a un bonus la case source est vide on doit donc prendre la case source d'avant !!
         
         LeSerpent[dest] := TShape.Create(LeSerpent[Source].owner);
         LeSerpent[dest].Parent := LeSerpent[Source].Parent ;
         LeSerpent[dest].top := LeSerpent[Source].top ;
         LeSerpent[dest].left := LeSerpent[Source].left ;
         LeSerpent[dest].width := TAILLE ;
         LeSerpent[dest].height := TAILLE ;
         LeSerpent[dest].brush.Color := Lacouleur;

      end;

(******************************************************************************)
(*                 Changement de direction                                    *)
(******************************************************************************)

      //explication de la gestion de la direction :
      //Pour eviter le probleme d'un haut gauche par exmeple pas pris en compte parsque appu
      //trop rapidement ( deux appuye simultan sans execution de la methode avancer ),
      //on sauvegarde toutes les touches de directions appuys par l'utilisateur  partir de la case 1 du tableau ladirection
      //et on "coule" ces cases de tableau a chaque appel a la mthode avancer
      //ainsi tous les appuye du joueur seront pris en compte quelque soit la rapidit
      //La case zero seravnt a sauvegard en cas de non appuye sur une touche la derniere direction emprunt par le serpent

      procedure Tserpent.changerdirection( nouvelledirection : integer );
      begin

      if ( ( Ladirection[length(LaDirection) -1 ] + nouvelledirection) mod 2 = 0 ) or ( Ladirection[length(LaDirection) -1 ] = nouvelledirection )  then
      exit;
      //si on va a gauche et que l'on tappe droit ou l'inverse et idem pour haut et bas on ne change pas de direction
      //En d'autre terme on interdit les retours en arrire
      //Ou si la direction est la meme que la precedente, en d'autre termes si on appuis sur gauche alors
      //que l'on allais a gauche

      setlength (LaDirection , length(LaDirection) +1 );
      Ladirection[ length(LaDirection) - 1 ] := nouvelledirection;

      end;


(******************************************************************************)
(*                 Changement de direction                                    *)
(******************************************************************************)
      function Tserpent.avancer( Form : TForm ):boolean;
      var  compteur : integer;
           LadirectionImmediate : integer;
      begin
          //On avance
          for compteur := length( LeSerpent )-1 downto 1 do
          begin
          clone( compteur-1 , compteur );
          end;
          
          result := true;

          if length(LaDirection) > 1 then LadirectionImmediate := LaDirection[1]   //si une touche est sauvegard on va dans la direction de cette touche
          else
          LadirectionImmediate := LaDirection[0];  //sinon on va dans la direction que l'on allait dja

          //changement de direction
          case LadirectionImmediate of
          //On test les colisions avant d'avancer effectivement, si avec des nouvelles coordonne le serpent de mord la queue
          //ou se mange le mur, on renvoie false sinon on change les nouvelles coordonnes
          1 :    begin    //haut
                   if Not TestCollision( Form , LeSerpent[1].Left   , LeSerpent[1].top -TAILLETETE )then result := false else
                   begin
                     LeSerpent[0].top := LeSerpent[1].top -TAILLETETE ;
                     LeSerpent[0].Left := LeSerpent[1].Left ;
                   end;
                 end;

          2 :    begin    //droite
                   if Not TestCollision( Form , LeSerpent[1].Left+TAILLETETE   , LeSerpent[1].top )then result := false else
                   begin
                     LeSerpent[0].top := LeSerpent[1].top ;
                     LeSerpent[0].Left := LeSerpent[1].Left+TAILLETETE ;
                   end;
                 end;

          3 :    begin    //bas
                   if Not TestCollision( Form , LeSerpent[1].Left   , LeSerpent[1].top + TAILLETETE )then result := false else
                   begin
                     LeSerpent[0].top := LeSerpent[1].top + TAILLETETE ;
                     LeSerpent[0].Left := LeSerpent[1].Left ;
                   end;
                 end;

          4 :    begin    //gauche
                   if Not TestCollision( Form , LeSerpent[1].Left-TAILLETETE  , LeSerpent[1].top )then result := false else
                   begin
                     LeSerpent[0].top := LeSerpent[1].top ;
                     LeSerpent[0].Left := LeSerpent[1].Left -TAILLETETE ;
                   end;
                 end;
          end;

          //si il reste des touches sauvegards dans le tableau on supprime la premiere sinon on sort
          if length(LaDirection) < 2 then
            exit;

          for compteur := 0 to length(LaDirection) - 2  do
          begin
           LaDirection[ compteur ] := LaDirection[compteur +1 ];
          end;
          setlength (LaDirection , length(LaDirection) -1 );

      end;


(******************************************************************************)
(*                 Test Collision                                             *)
(******************************************************************************)
      function   Tserpent.TestCollision(Form : TForm ; newleft , newtop : integer ):boolean;
      var compteur : integer;
      begin
          //verification collision
          result := true;
          for  compteur := 1 to length( LeSerpent ) -1 do
          begin
            //Si il se mort la queue ..
            if (LeSerpent[compteur].Top = newTop ) and (LeSerpent[compteur].left = newleft ) then
            begin
              result := false;
            end;
          end;

          //Si il tappe un mur ...
          if ( newtop < 0 ) OR ( newleft < 0 ) OR (  newtop > ( Form.ClientHeight -20 - LeSerpent[0].Height ) ) OR (  newleft > ( Form.Clientwidth - LeSerpent[0].width) )then
          begin
            result := false;
          end;
      end;



(******************************************************************************)
(*                 Test Bonus                                                 *)
(******************************************************************************)
      function   Tserpent.TestBonus( MonBonus : TBonus ):boolean;
      begin
          //Si il rencontre un bonus
          Result:=false;
          if ( Monbonus.top = LeSerpent[0].top) and ( MonBonus.left = LeSerpent[0].left )  then
          begin
            Result := true;
            case MonBonus.NumGenre of
            1 : begin
                //rien de speciale ...
                end;

            2 : begin
                grandir;
                end;

            3 : begin
                grandir;
                if( LaVitesse > VITESSEMAX ) then   //on limite m'horloge, on ne descend pas en dessous de vitessemax
                LaVitesse := LaVitesse - 5 ;
                end;
            end;    

          end;
      end;


(******************************************************************************)
(*                 Test Prsence                                              *)
(******************************************************************************)
     function   Tserpent.TestPresenceSerpent( Left , Top : integer ):boolean;     //renvoie true si une partie du serpent est a ces coordonnes
     var compteur : integer;
     begin
       Result := false;
        for  compteur := 0 to length( LeSerpent )-1 do
        begin
          if( LeSerpent[compteur] = nil )then break;

          if( LeSerpent[compteur].left = Left ) and ( LeSerpent[compteur].top = Top )then
          begin
            Result := true;
            break;
          end;
        end;
     end;



(******************************************************************************)
(*                 Grandir                                                    *)
(******************************************************************************)
      procedure Tserpent.grandir();
      begin
        //on agrandit le serpent, l'agrandissement sera vraiment effectif lors du prochain avancement
        setlength( LeSerpent , length(LeSerpent)+1 );
      end;



(******************************************************************************)
(*                Chenagement de direction auto                               *)
(******************************************************************************)
//le changement de direction consiste pour l'instant  regarder si la distance
//la plus longue de la tete du serpent jusqu'au bonus est plus longue en
//coordonne left ou top, et adapter la direction a cette distance
//on ne prend pas en compte pour l'instant l'autre serpent ou meme
//son propre serpent, donc les risques de collision avec l'autre ou sa propre
//queue son possbile


      procedure Tserpent.ChangerdirectionAutomatique(MonBonus: Tbonus);
      Var
      EcartTop : integer;
      EcartLeft : integer;
      begin
      //gestion de la direction Artificielle du serpent  :
      EcartTop := Monbonus.top - top(0) ;
      EcartLeft := Monbonus.left - left(0);

      if abs(EcartTop) > abs(EcartLeft) then
      begin
        if EcartTop < 0 then
        begin
          if direction <> BAS then
            changerdirection( HAUT)
          else
          begin
            if EcartLeft < 0 then
              changerdirection(GAUCHE)
            else
              changerdirection(DROITE);
          end;
        end
        else       // inf a 0
        begin
          if direction <> HAUT then
            changerdirection(BAS)
          else
          begin
            if EcartLeft < 0 then
              changerdirection(GAUCHE)
            else
              changerdirection(DROITE);
          end;
        end;

      end
      else
      begin

        if EcartLeft < 0 then
        begin
          if direction <> DROITE then
            changerdirection(GAUCHE)
          else
          begin
             if EcartTop < 0 then
              changerdirection(HAUT)
            else
              changerdirection(BAS);
          end;
        end
        else        //inf  0
        begin
          if direction <> GAUCHE then
            changerdirection(DROITE)
          else
          begin
            if EcartTop < 0 then
              changerdirection(HAUT)
            else
              changerdirection(BAS);
          end;
        end;
      end;
   end;


(******************************************************************************)
(*                Renvoie TOP suivant rang                                    *)
(******************************************************************************)
      function Tserpent.top(rang : integer):integer;
      begin
        result:=LeSerpent[rang].Top;
      end;


(******************************************************************************)
(*                Renvoie LEFT suivant rang                                   *)
(******************************************************************************)
      function Tserpent.left(rang : integer):integer;
      begin
        result:=LeSerpent[rang].left;
      end;


(******************************************************************************)
(*                Renvoie Vitesse du serpent                                  *)
(******************************************************************************)
      function  TSerpent.vitesse:integer;
      begin
        result:= LaVitesse;
      end;


(******************************************************************************)
(*                Renvoie Direction effective                                 *)
(******************************************************************************)
      function  TSerpent.direction:integer;
      begin
        result:= LAdirection[0] ;
      end;


(******************************************************************************)
(*               detruit visuellement le serpent                              *)
(******************************************************************************)
      destructor TSerpent.detruire;
      var
      compteur : integer;
      begin
        if  length( LeSerpent ) = 0 then exit;
          for  compteur := 0 to length( LeSerpent )-1 do
          begin
          if LeSerpent[compteur] <> nil then
            LeSerpent[compteur].Destroy;
          end;
      end;



end.

